my $rsize = "";
my $asize = "";
my $lsize = "";
my $filename = "";
my $datapath = "";
my $ctof = "";
my $frames= "";

open(my $fh, '<', 'parameter.conf') or die "Can't open file";
while (my $line = <$fh>){
	if ( $line =~ 'X_RSIZE'){
                $rsize = $line;
	}
	if( $line =~ 'X_ASIZE'){
		$asize = $line;
	}
	if( $line =~ 'X_LSIZE'){
		$lsize = $line;
	}
	if( $line =~ 'X_CTOF'){
	    $ctof = $line;
	}
	if( $line =~ 'X_DATAPATH'){
	    $datapath = $line;
	}
	if( $line =~ 'X_FILENAME'){
                $filename = $line;
        }
	if( $line =~ 'X_FRAMES'){
                $frames = $line;
        }


}

system "cp ./template/cal_mean_RR.c run1.c";

if ($rsize =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_RSIZE/$1/g' run1.c");
	$rsize=$1;
}

if ($asize =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_ASIZE/$1/g' run1.c");
}

if ($lsize =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_LSIZE/$1/g' run1.c");
}

if ($filename =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_FILENAME/$1/g' run1.c");
}

if ($datapath =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's#X_DATAPATH#$1#g' run1.c");
}
if ($ctof =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_CTOF/$1/g' run1.c");
}
if ($frames =~ m/= \s* (\S+)/x) {
    $frames =$1;
}



system("gcc -O2 -lm run1.c");
system("./a.out $frames");
system("echo mean.con generated");
#system("cp mean.con ../result/");

system("sort -gr -k 3 mean.con | awk '{print NR, \$3}'>  rcf.dat"); 
#system("cp rcf.dat ../result/");
system("echo rcf.dat generated");

system("awk 'BEGIN{s=0;}{ if (\$1!=\$2) s=s+\$3;}END{print \"ncn=\", 2.0*s/$rsize;}' mean.con >> j50_ncn.dat");
#system("grep -v j50 j50_ncn.dat > temp.j50_ncn.dat ; mv temp.j50_ncn.dat j50_ncn.dat");
system("awk < rcf.dat '{ if (\$2>0.5) print \"j50=\",NR}' | tail -n 1 >> j50_ncn.dat");

close $fh

