my $rsize = "";
my $asize = "";
my $lsize = "";
my $csize = ""; # csize is the size of sel.con
my $filename = "";
my $datapath = "";
my $ctof = "";
my $frames= "";
my $lco= "";
my $hco= "";
my $seg="";

open(my $fh, '<', 'parameter.conf') or die "Can't open file";
while (my $line = <$fh>){
	if ( $line =~ 'X_RSIZE'){
                $rsize = $line;
	}
	if( $line =~ 'X_ASIZE'){
		$asize = $line;
	}
	if( $line =~ 'X_LSIZE'){
		$lsize = $line;
	}
	if( $line =~ 'X_CTOF'){
	    $ctof = $line;
	}
	if( $line =~ 'X_DATAPATH'){
	    $datapath = $line;
	}
	if( $line =~ 'X_FILENAME'){
                $filename = $line;
        }
	if( $line =~ 'X_FRAMES'){
                $frames = $line;
        }
	if( $line =~ 'X_low_co'){
		$lco = $line;
	}
	if( $line =~ 'X_high_co'){
		$hco = $line;
	}
	if( $line =~ 'X_SEG'){
	    $seg = $line;
	}
	
	
}

# create sel.con step 2a
if ($lco =~ m/= \s* (\S+)/x) {
    $lco=$1;
}
if ($hco =~ m/= \s* (\S+)/x) {
    $hco=$1;
}

system ("awk '{if (\$3<$hco && \$3>$lco) print \$1, \$2, \$3}' < ./mean.con > ./sel.con");
#system ("cp ./sel.con .");

open(FILE, "<./sel.con") or die "Could not open file: $!";
 while (<FILE>) {
    $csize++;
}


# put CSIZE info  into parameter.conf, add it in here

#print "$csize\n";
system "grep -v CSIZE ./parameter.conf > temp";
system "echo X_CSIZE=$csize >> temp"; 
system "mv temp parameter.conf"; 

# creat covar.dat step 1b

system "cp template/cal_covar_SS.c run2.c";

if ($rsize =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_RSIZE/$1/g' run2.c");
}

if ($asize =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_ASIZE/$1/g' run2.c");
}

if ($lsize =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_LSIZE/$1/g' run2.c");
}

if ($filename =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_FILENAME/$1/g' run2.c");
}

if ($datapath =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's#X_DATAPATH#$1#g' run2.c");
}
if ($ctof =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's/X_CTOF/$1/g' run2.c");
}
if ($seg =~ m/= \s* (\S+)/x) {
    print "$1 \n";
    system("perl -p -i -e 's#X_SEG#$1#g' run2.c");
}

    system("perl -p -i -e 's/X_CSIZE/$csize/g' run2.c");

if ($frames =~ m/= \s* (\S+)/x) {
    $frames =$1;

}





print "the range is $lco - $hco\n";
system("gcc -O2 run2.c -lm");
system("./a.out $frames ");

close $fh

