//THIS CODE HAS BEEN FIXED AT READIN 

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#define rsize X_RSIZE // number residue
#define asize X_ASIZE // atom number per system
#define csize X_CSIZE // dof of contacts
#define LL X_LSIZE // exact number of the segments of the system 
#define ctof X_CTOF // cutoff distance



int main(int argc, char **argv){
FILE * fp;
FILE * fcovar;
FILE * cl;

int m,i,j,l,k;
int L;
int iend, jend, istart, jstart;
int rid[asize+1];
float x[asize+1];
float y[asize+1];
float z[asize+1];
 int cm[rsize+1][rsize+1]; // a frames contact matrix at RR level
 float dm[LL+1][LL+1]; // the storage space for instant value at CG level 
 int sega[csize+1], segb[csize+1];
 int trash_int;
 double *avg; //double avg[csize+1];  

 double *zm; //the storage space for the cov matrix
char trash[100];
char pdb[115];
char pdbf[115];
 char line[200];
 char key1[200];

int framecount=0;
  int seq[LL+1]={0,X_SEG,rsize};
 

//first segment 1 to 33, and second is 34-51, etc.

 zm=malloc(sizeof(double)*(csize*csize+1));
 avg=malloc(sizeof(double)*(csize+1));

 // if L==0, print no CG else print do CG
if(LL==0) { L=rsize;} else L=LL;


 cl=fopen("sel.con","r");
 // readin and define resa, resb, avg  
 for(i=1;i<=csize;i++) {
   trash_int = fscanf(cl,"%d%d%lf",&sega[i],&segb[i],&avg[i]);
 }

 
framecount=atoi(argv[1]);

 for(i=0;i<=csize*csize;i++) {   zm[i]=0.0;}

for(m=1;m<=framecount;m++){  //loop through pdbs
  strcpy(pdb,"X_DATAPATH");
  sprintf(pdbf,"X_FILENAME.%d",m);
  strcat(pdb,pdbf);
  //  strcat(pdb,".pdb");
printf("%s\n",pdb);
  fp=fopen(pdb,"r");
  //printf("file opened\n");

  //read in coords          
  i=0;
  while( fgets(line, sizeof(line), fp)) {
    sscanf(line, "%s", key1);
    if(!strncasecmp(key1, "ATOM",4))
      { i++;
       sscanf(line,"%s%s%s%s%d%f%f%f%s%s",trash,trash,trash,trash,&rid[i],&x[i],&y[i],&z[i],trash,trash);
      }
  }

   //        printf("fscanf loop done\n");

    for(i=1;i<=rsize;i++){   //initialize array
      for(j=1;j<=rsize;j++){
        cm[i][j]=0;
      } 
    } 
    for(i=1;i<=L;i++){   //initialize array                                                                                                     
      for(j=1;j<=L;j++){
        dm[i][j]=0.0;
      }
    }

    for(i=1;i<=asize;i++)   //check for contact
      {
      for(j=i;j<=asize;j++)
        {
         if (((x[i]-x[j])*(x[i]-x[j])+
         (y[i]-y[j])*(y[i]-y[j])+
         (z[i]-z[j])*(z[i]-z[j]) < ctof*ctof) /*&& (abs(rid[i]-rid[j]) >= 4*/)
           {
           cm[rid[i]][rid[j]]=1;
	   cm[rid[j]][rid[i]]=1;

            }
        }
    }
    // printf("contact check complete\n");
    // convert from single frame to sum
   for(i=1;i<=L;i++){  //increment sum array
     //              printf("Entering new loop\n");
          for(j=i;j<=L;j++){   //changed j=1 to j=i
	    
	    istart=seq[i-1]+1;
	  jstart=seq[j-1]+1;
	    iend=seq[i]; 
	    jend=seq[j];
	    //  printf(" %d %d %d %d end first new loop\n",istart,iend,jstart,jend);
	    for(k=istart; k<= iend;k++)
	      {
		for(l=jstart; l<= jend;l++)
		  {
		    //again k,l at rr level and i,j at cg level
		    

		    // 3 versions: A, L, E:

		    //option 1:
		    // <= verions E count total number of contacts =>
		    // if(cm[k][l]==1){dm[i][j]+=1.0;}

		    //opition 2:
		    //<= version L: norm by sqrt =>
		    if(cm[k][l]==1){dm[i][j]+=1.0/sqrt((iend-istart+1.0)*(jend-jstart+1.0));}

		    //option 3:
		    // <= version A: number normalized by area  =>
		    // if(cm[k][l]==1){dm[i][j]+=1.0/((iend-istart+1.0)*(jend-jstart+1.0));}
			    
		
		  } //ending l
	      } //ending k

	  } //end j 
   } //ending i
      fclose(fp);
      // our 2D to 1D array conversion is i+(j-1)*csize
      for(i=1;i<=csize;i++)
	{
	  for(j=1;j<=csize;j++)
	    {
	      zm[i+(j-1)*csize]+=(dm[sega[i]][segb[i]]-avg[i])*(dm[sega[j]][segb[j]]-avg[j]);
		}
	}

 }//ending loop m, reading frames
fcovar=fopen("covar.dat","w");

 fcovar=fopen("covar.dat","w");
 for(i=1;i<=csize;i++){   //print results                                                                                 
   for(j=1;j<=csize;j++){
     fprintf(fcovar,"%3d %3d %e\n",i,j,zm[i+(j-1)*csize]/framecount); 

   }
 }

fclose(fcovar);
}
