//THIS CODE HAS BEEN FIXED AT READIN 

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#define rsize X_RSIZE // number residue
#define asize X_ASIZE // atom number of system
#define LL X_LSIZE // exact number of the segments of the system 
#define ctof X_CTOF // cutoff distance
#define csize X_CSIZE // dof of contacts    

int main(int argc, char **argv){
FILE * fp;
 FILE * cl;  //sel.con
 FILE * fproj; //output file
 FILE * pp1; //vect pc1
 FILE * pp2; //vect pc2       

int m,i,j,l,k;
int L;
int iend, jend, istart, jstart;

 float vpc1[csize+1];
 float vpc2[csize+1];
 float pc1;
 float pc2;
 int resa[csize+1], resb[csize+1];
 //long double *avg; //double avg[csize+1];
 double *avg; //double avg[csize+1];
 
 double area;
 //  avg=malloc(sizeof(long double)*(csize+1));
 avg=malloc(sizeof(double)*(csize+1));
 
int rid[asize+1];
float x[asize+1];
float y[asize+1];
float z[asize+1];
int cm[rsize+1][rsize+1];
//float lm[rsize+1][rsize+1]; // need to change later for rsize or LL
 float lm[LL+1][LL+1];
char trash[100];
char pdb[115];
char pdbf[115];
char line[200];
char key1[200];
int framecount=0;
int seq[LL+1]={0,X_SEG,rsize};
 int trash_int;
//except "1", all are ending residue indices of segments 


 fproj=fopen("proj_output.dat","w");
 cl=fopen("./sel.con","r");
 for(i=1;i<=csize;i++) {
   //   fscanf(cl,"%d%d%s",&resa[i],&resb[i],trash);
   trash_int = fscanf(cl,"%d%d%lf",&resa[i],&resb[i],&avg[i]);
   trash_int = fscanf(cl,"%d%d%lf",&resa[i],&resb[i],&avg[i]);
   
 }
 pp1=fopen("x.pc1","r");
 pp2=fopen("x.pc2","r");
 for(i=1;i<=csize;i++) {
  trash_int = fscanf(pp1,"%f",&vpc1[i]);
   trash_int = fscanf(pp2,"%f",&vpc2[i]);
  }
 fclose(pp1);
 fclose(pp2);
 
 
 // if L==0, print no CG else print do CG
if(LL==0) { L=rsize;} else L=LL;

 
 
framecount=atoi(argv[1]);

for(i=1;i<=L;i++){   //initialize array
      for(j=1;j<=L;j++){
        lm[i][j]=0.0;
      }
}


for(m=1;m<=framecount;m++){  //loop through pdbs
  strcpy(pdb,"X_DATAPATH");
  sprintf(pdbf,"X_FILENAME.%d",m);
  strcat(pdb,pdbf);
  //  strcat(pdb,".pdb");
printf("%s\n",pdb);
  fp=fopen(pdb,"r");
  //printf("file opened\n");

  //read in coords 
  i=0;
  while( fgets(line, sizeof(line), fp)) {

    sscanf(line, "%s", key1);
    if(!strncasecmp(key1, "ATOM",4))
      { i++;
      sscanf(line,"%s%s%s%s%d%f%f%f%s%s",trash,trash,trash,trash,&rid[i],&x[i],&y[i],&z[i],trash,trash);
      }
  }
   //        printf("fscanf loop done\n");
    for(i=1;i<=rsize;i++){   //initialize array
      for(j=1;j<=rsize;j++){
        cm[i][j]=0;
      } 
    } 
    for(i=1;i<=asize;i++)   //check for contact
      {
      for(j=i;j<=asize;j++)
        {
         if (((x[i]-x[j])*(x[i]-x[j])+
         (y[i]-y[j])*(y[i]-y[j])+
         (z[i]-z[j])*(z[i]-z[j]) < ctof*ctof) /*&& (abs(rid[i]-rid[j]) >= 4*/)
           {
           cm[rid[i]][rid[j]]=1;
	   cm[rid[j]][rid[i]]=1;

            }
        }
    }
    // printf("contact check complete\n");
    // convert from single frame to sum
   for(i=1;i<=L;i++){  //increment sum array
     //              printf("Entering new loop\n");
          for(j=i;j<=L;j++){   //changed j=1 to j=i
	    
	   istart=seq[i-1]+1;
	   jstart=seq[j-1]+1;
           
	    iend=seq[i]; 
	    jend=seq[j];
	    area=(iend-istart+1.0)*(jend-jstart+1.0);
	    //  printf(" %d %d %d %d end first new loop\n",istart,iend,jstart,jend);
	    for(k=istart; k<= iend;k++)
	      {
		for(l=jstart; l<= jend;l++)
		  {

		    //three versions A, L, E		    
		    //1: version A
		    lm[i][j]+=cm[k][l]*1.0/area;

		    //2: version L
		    lm[i][j]+=cm[k][l]*1.0/sqrt(area);

		    //3: version E
		    lm[i][j]+=cm[k][l]*1.0;
		    

		  } //ending l
	      } //ending k
	  } //end j 
   } //ending i

   // proj cal
   pc1=0.0; pc2=0.0;
   for(i=1;i<=csize;i++)
     {
       pc1+=lm[resa[i]][resb[i]]*vpc1[i];
       pc2+=lm[resa[i]][resb[i]]*vpc2[i];
     }
   fprintf(fproj,"%12.7f %12.7f \n", pc1,pc2);

     //clean up lm for the next frame
     for(i=1;i<=L;i++){  
       for(j=1;j<=L;j++){
	 lm[i][j]=0.0;
       }
     }
 
      fclose(fp);
      
 }// finish the loop on reading frames
 fclose(fproj);
 
}
