//Color scheme compatible with VMD 1.9.1 and 1.8.7

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define N 474 // csize
#define YMIN 33
#define YMAX 1024
#define XMAX 0.8
#define XMIN 0.2  

int main() {
  double x[N+1];
  double y[N+1]; 
  double z[N+1]; 
  int b1[1000];
  int b2[1000];
  double b3[1000];
  
  char line[230];  char key1[200];char key2[200]; 
  char key3[200]; 


  FILE* fp;
  FILE* fp2; 
  int i,j,k,m;

  fp  = fopen("xyz.dat", "r");
  fp2 = fopen("3D.con", "r"); 

  for(i=1;i<=N;i++)
    {
      fgets(line, 220, fp);
      sscanf(line, "%s%s%s%s", key1, key1,key2,key3);
      x[i]=atof(key1);
      y[i]=atof(key2); 
      z[i]=atof(key3); 

    }

  i=1;
  while(fgets(line,220,fp2))
    { sscanf(line, "%s%s%s", key1,key2,key3); 
      b1[i]=atoi(key1); 
      b2[i]=atoi(key2);  
      b3[i]=atof(key3); 
      //    printf("xxx %d %d %e\n", b1[i],b2[i],b3[i]);  
      i++;
    }
  

  //print color

  for(i=1;i<=N;i++)
  {
    //scale
   b3[i]=(b3[i]-XMIN)/((XMAX-XMIN)/(YMAX-YMIN))+YMIN; 
   
   printf("draw color %d\n", (int)(b3[i]));

   printf("draw cylinder { %f %f %f } { %f %f %f } radius 0.5 resolution 20\n", x[b1[i]], y[b1[i]], z[b1[i]], 
x[b2[i]], y[b2[i]], z[b2[i]]);

  }
 

}
