//this color range is fored to be symmetric. 
// this code will map to RWB vmd color from 33 to 1056 (total 1024 values)
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define rsize 493 // number residue
#define asize 7891 // atom number per system
#define csize 309 // dof of contacts
#define LL 44 // exact number of the segments of the system 
#define ctof 4.2 // cutoff distance

#define YMIN 33
#define YMAX 1056


int main(int argc, char **argv){
  FILE * fp;
 FILE * cl;

 int m,i,j,l,k, ntemp;
 int L;
 int iend, jend, istart, jstart;
 int rid[asize+1];
 float xtemp, ytemp, ztemp;
 float  XMAX=-1000000.0;
 float XMIN=1000000.0;
 float xs[LL+1];
 float ys[LL+1];
 float zs[LL+1];

 float x[asize+1];
 float y[asize+1];
 float z[asize+1];

 int sega[csize+1];
 int segb[csize+1];
 int trash_int;
 char trash[100];
 char pdb[115]="rxr1tr1.1";
 char line[230];
 char key1[200];
 char key2[200];
 int b1[1000];
 int b2[1000];
 double b3[1000];
 char key3[200];
 int seq[LL+1]={0,33,48,57,86,95,105,117,124,135,141,147,159,164,176,186,208,214,232,244,250,259,275,287,294,317,326,336,348,355,366,372,378,391,396,408,418,440,446,464,475,481,491,492,rsize};
 long double avgtemp;
 long double *avg; //double avg[csize+1];
  avg=malloc(sizeof(long double)*(csize+1));

 cl=fopen("pc1.con","r");

 i=1;
  while(fgets(line,220,cl))
    { sscanf(line, "%s%s%s", key1,key2,key3);
      sega[i]=atoi(key1);
      segb[i]=atoi(key2);
      avg[i]=atof(key3);
      if (avg[i]>XMAX) {XMAX=avg[i];}
      if (avg[i]<XMIN) {XMIN=avg[i];}
     
      i++;
    }

  if (XMAX*XMAX> XMIN*XMIN)
    { XMIN= -XMAX;}
  else
    { XMAX= -XMIN;}
      
m=csize-1; 


  fp=fopen(pdb,"r");

  //read in coords          
  i=1;
  while( fgets(line, sizeof(line), fp)) {
    sscanf(line, "%s", key1);
    if(!strncasecmp(key1, "ATOM",4))
      { i++;
       sscanf(line,"%s%s%s%s%d%f%f%f%s%s",trash,trash,trash,trash,&rid[i],&x[i],&y[i],&z[i],trash,trash);
      }
  }
for(i=1;i<LL+1;i++){
  ntemp=0;
  xtemp=0.0;
  ytemp=0.0;
  ztemp=0.0;

  // for seg # i, first one: seg[i-1]+1 last resi seg[i]
  for(j=1;j<asize+1;j++){
    if( (rid[j]>=seq[i-1]+1)&&(rid[j]<=seq[i]))
      { ntemp++; xtemp+=x[j]; ytemp+=y[j]; ztemp+=z[j];}
  }
  xs[i]=xtemp/(ntemp*1.0);
  ys[i]=ytemp/(ntemp*1.0);
  zs[i]=ztemp/(ntemp*1.0);
  //printf("%d %f %f %f\n",i,xr[i],yr[i],zr[i]);
} 

 for(i=1;i<=csize;i++)
  {
   avgtemp=(avg[i]-XMIN)/((XMAX-XMIN)/(YMAX-YMIN)) +YMIN; //set color
   
   if(avg[i]>XMAX){ avgtemp=YMAX;}
   if(avg[i]<XMIN){ avgtemp=YMIN;}
   
//     else{
     if(sega[i]==segb[i]){
       printf("draw color %d\n", (int)(avgtemp));
       printf("draw sphere { %f %f %f } radius 3.0\n",xs[sega[i]],ys[sega[i]],zs[sega[i]]);
     }
     else{
     if(avg[i] > 0.0200 || avg[i] < -0.0200){
       printf("draw color %d\n", (int)(avgtemp));
       printf("draw cylinder { %f %f %f } { %f %f %f } radius 0.5 resolution 20\n", xs[sega[i]], ys[sega[i]], zs[sega[i]],
xs[segb[i]], ys[segb[i]], zs[segb[i]]);
        }
     }
   }
// }
}
