####################
#  This script is the front end to the library
#  v0.01 2/17/2017
#################
import numpy as np
from camerra import CamerraParameters as parm
from camerra import SegmentSegment as ss
from camerra import ResidueResidue as rr

#Load Segment Values
mySS = ss()
segment_values = mySS.importSegmentValues("data/final_visualization_02092017/covar_44E_SS.con")

#Load Segment to Residue Map
#Load Segment List and Transpose Array
myparam = parm("data/final_visualization_02092017/parameter_temp.conf")
map = np.array(myparam.getSegments()).T

#Convert Segment Segment to Residue Residue
#Write Output File
myRR = rr()
myRR.convertSStoRR(map,segment_values)
myRR.writeFile("data/final_visualization_02092017/covar_44E_RR_from_SS.con")
