// converting sparse upper triangle .con type of files
// to full symmetric form
// scale level scale will expand one contact to a range of [-scale,+scale],
//scale=0 is unscaled, the acutal linear scale factor is 2*scale+1
// hardwired, stand-alone tool
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define N 88
#define ss 0
#define small_cut 0.0000001
float val[N+1+1][N+1+1];
// first +1 to make our matrix starting count at 1
// second +1 to add extra border line with 0 or mathematica display will cut off the last line

int main() {
  
  float z; 
  
  char line[230]; 

  FILE* fp;
 
  int i,j,k,m, xmin,xmax,ymin,ymax,ii,jj,scale;

  fp  = fopen("input.con", "r");

  for(i=1;i<=N+1;i++)
    {
      for(j=1;j<=N+1;j++)
	{
	  val[i][j]=0.0;
	}
    }


  while( fgets(line, 220, fp)) 
    {
      sscanf(line, "%d%d%f",&i,&j,&z);
      if(z*z>small_cut*small_cut)
	{scale=ss;}
      else
	{scale=0;}
      
      xmin=i-scale;
      if (xmin<1) {xmin=1;}
      xmax=i+scale;
      if (xmax>N) {xmax=N;}
      ymin=j-scale;
      if (ymin<1) {ymin=1;}
      ymax=j+scale;
      if (ymax>N) {ymax=N;}
      
      for(ii=xmin;ii<=xmax;ii++)
	{
	  for(jj=ymin;jj<=ymax;jj++)
	    {
	      val[ii][jj]=z;
	      val[jj][ii]=z;
	    }
	}
    }
  
    for(i=1;i<=N+1;i++)
  {
    for(j=1;j<=N+1;j++)
      {
	//	printf("%d %d %.12e\n", i,j,val[i][j]);
	printf("%d %d %e\n", i,j,val[i][j]);   
      }
  }
  
}
