//this color range is fored to be symmetric. 
// this code will map to RWB vmd color from 33 to 1056 (total 1024 values)
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define rsize 744 // number residue
#define asize 11898 // atom number per system
#define csize 133 // dof of contacts
#define LL 88 // exact number of the segments of the system 
#define ctof 4.2 // cutoff distance

#define YMIN 33
#define YMAX 1056


int main(int argc, char **argv){
FILE * fp;
FILE * cl;

 int m,i,j,l,k, ntemp;
int L;
int iend, jend, istart, jstart;
int rid[asize+1];
 float xtemp, ytemp, ztemp;
 float  XMAX=-1000000.0;
 float XMIN=1000000.0;
float xs[rsize+1];
float ys[rsize+1];
float zs[rsize+1];
//float xs[LL+1];
//float ys[LL+1];
//float zs[LL+1];
float x[asize+1];
float y[asize+1];
float z[asize+1];
int sega[csize+1];
int segb[csize+1];
int trash_int;
char trash[100];
char pdb[115]="0t0.avg";
char line[230];
char key1[200];
char key2[200];
int b1[1000];
int b2[1000];
double b3[1000];
char key3[200];
 int seq[LL+1]={0,5,8,14,24,34,45,51,67,71,89,92,103,116,127,133,141,155,161,165,180,194,200,207,216,222,226,243,246,251,256,261,266,269,285,295,300,306,314,326,333,343,349,363,376,381,385,400,403,407,413,416,420,444,450,453,461,483,487,498,501,506,514,520,549,557,565,572,579,592,605,611,622,629,637,648,651,662,672,680,686,700,709,712,715,731,736,742,rsize};

long double avgtemp;
long double *avg; //double avg[csize+1];
  avg=malloc(sizeof(long double)*(csize+1));

 cl=fopen("pc1_0t0.con","r");
i=1;
  while(fgets(line,220,cl))
    { sscanf(line, "%s%s%s", key1,key2,key3);
      sega[i]=atoi(key1);
      segb[i]=atoi(key2);
      avg[i]=atof(key3);
      if (avg[i]>XMAX) {XMAX=avg[i];}
      if (avg[i]<XMIN) {XMIN=avg[i];}
     
      i++;
    }

  if (XMAX*XMAX> XMIN*XMIN)
    { XMIN= -XMAX;}
  else
    { XMAX= -XMIN;}
      
m=csize-1; 


  fp=fopen(pdb,"r");

  //read in coords          
  i=0;
  while( fgets(line, sizeof(line), fp)) {
    sscanf(line, "%s", key1);
    if(!strncasecmp(key1, "ATOM",4))
      { i++;
       sscanf(line,"%s%s%s%s%d%f%f%f%s%s",trash,trash,trash,trash,&rid[i],&x[i],&y[i],&z[i],trash,trash);
      }
  }
for(i=1;i<LL+1;i++){
  ntemp=0;
  xtemp=0.0;
  ytemp=0.0;
  ztemp=0.0;

  // for seg # i, first one: seg[i-1]+1 last resi seg[i]
  for(j=1;j<asize+1;j++){
    if( (rid[j]>=seq[i-1]+1)&&(rid[j]<=seq[i]))
      { ntemp++; xtemp+=x[j]; ytemp+=y[j]; ztemp+=z[j];}
  }
  xs[i]=xtemp/(ntemp*1.0);
  ys[i]=ytemp/(ntemp*1.0);
  zs[i]=ztemp/(ntemp*1.0);
  //printf("%d %f %f %f\n",i,xr[i],yr[i],zr[i]);
} 

 for(i=1;i<=m;i++)
  {
   avgtemp=(avg[i]-XMIN)/((XMAX-XMIN)/(YMAX-YMIN)) +YMIN; //set color
   
   if(avg[i]>XMAX){ avgtemp=YMAX;}
   if(avg[i]<XMIN){ avgtemp=YMIN;}
   
//     else{
     if(sega[i]==segb[i]){
       printf("draw color %d\n", (int)(avgtemp));
       printf("draw sphere { %f %f %f } radius 3.0\n",xs[sega[i]],ys[sega[i]],zs[sega[i]]);
     }
     else{
     if(avg[i] > 0.0200 || avg[i] < -0.0200){
       printf("draw color %d\n", (int)(avgtemp));
       printf("draw cylinder { %f %f %f } { %f %f %f } radius 0.5 resolution 20\n", xs[sega[i]], ys[sega[i]], zs[sega[i]],
xs[segb[i]], ys[segb[i]], zs[segb[i]]);
        }
     }
   }
// }
}
