my $rsize = "";
my $asize = "";
my $lsize = "";
my $csize = ""; # csize is the size of sel.con
my $filename = "";
my $datapath = "";
my $ctof = "";
my $frames= "";
my $lco= "";
my $hco= "";

open(my $fh, '<', 'parameter.conf') or die "Can't open file";
while (my $line = <$fh>){
	if ( $line =~ 'X_RSIZE'){
                $rsize = $line;
	}
	if( $line =~ 'X_ASIZE'){
		$asize = $line;
	}
        if( $line =~ 'X_CSIZE'){
	    	$csize = $line;
	}
	if( $line =~ 'X_LSIZE'){
		$lsize = $line;
	}
	if( $line =~ 'X_CTOF'){
	    $ctof = $line;
	}
	if( $line =~ 'X_DATAPATH'){
	    $datapath = $line;
	}
	if( $line =~ 'X_FILENAME'){
                $filename = $line;
        }
	if( $line =~ 'X_FRAMES'){
                $frames = $line;
        }
	if( $line =~ 'X_low_co'){
		$lco = $line;
	}
	if( $line =~ 'X_high_co'){
		$hco = $line;
	}

}

if ($csize =~ m/= \s* (\S+)/x) {
    $csize = $1;
}

system "cp template/diag_covar.f run3.f";
system("perl -p -i -e 's/X_CSIZE/$csize/g' run3.f");
system("gfortran run3.f -llapack -lblas -lm");
system("./a.out > ./eigen_values.dat");
system("awk '{print \$1, \$2}' ./sel.con > combine.temp");
system("paste combine.temp x.pc1 > ./pc1.con");
system("paste combine.temp x.pc2 > ./pc2.con");
unlink "combine.temp";



close $fh

