//THIS CODE HAS BEEN FIXED AT READIN 

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define rsize X_RSIZE // number residue
#define asize X_ASIZE // atom number per system
#define LL X_LSIZE // exact number of the segments of the system
#define ctof X_CTOF // cutoff distance
#define csize X_CSIZE // dof of contacts


int main(int argc, char **argv){
FILE * fp;
FILE * fcovar;
FILE * cl;

int m,i,j,l,k;
int L;
int iend, jend, istart, jstart;
int rid[asize+1];
float x[asize+1];
float y[asize+1];
float z[asize+1];
int cm[rsize+1][rsize+1]; // a frames contact matrix at RR level
int resa[csize+1], resb[csize+1];
double *avg; // store mean values from sel.con 
 double *zm; //the storage space for the cov matrix
char trash[100];
char pdb[115];
char pdbf[115];
 char line[200];
 char key1[200];

int framecount=0;

 int  trash_int;

 
 zm=malloc(sizeof(double)*(csize*csize+1));
 avg=malloc(sizeof(double)*(csize+1));

 // if L==0, print no CG else print do CG
 //if(LL==0) { L=rsize;} else L=LL;


 cl=fopen("sel.con","r");
 // readin from sel.con define resa, resb, avg  
 for(i=1;i<=csize;i++)
   {
     trash_int=  fscanf(cl,"%d%d%lf",&resa[i],&resb[i],&avg[i]);
     
   }

 
 framecount=atoi(argv[1]);

 // clear covar matrix 
 for(i=0;i<=csize*csize;i++) {   zm[i]=0.0;}
 
 for(m=1;m<=framecount;m++){  //loop through pdbs
   strcpy(pdb,"X_DATAPATH");
   sprintf(pdbf,"X_FILENAME.%d",m);
   
   strcat(pdb,pdbf);
  //  strcat(pdb,".pdb");
printf("%s\n",pdb);
  fp=fopen(pdb,"r");
  //printf("file opened\n");

  //read in coords          
  i=0;
  while( fgets(line, sizeof(line), fp)) {
    sscanf(line, "%s", key1);
    if(!strncasecmp(key1, "ATOM",4))
      { i++;
	sscanf(line,"%s%s%s%s%d%f%f%f%s%s",trash,trash,trash,trash,&rid[i],&x[i],&y[i],&z[i],trash,trash);
      }
  }
  
  //clear for single fram contact u_ij
   for(i=1;i<=rsize;i++)
    {
      for(j=1;j<=rsize;j++)
	{
	cm[i][j]=0;
	} 
    } 

  //check for contact       
    for(i=1;i<=asize;i++)  
      {
	for(j=i;j<=asize;j++)
	  {
	    if ( (x[i]-x[j])*(x[i]-x[j])+
		  (y[i]-y[j])*(y[i]-y[j])+
		 (z[i]-z[j])*(z[i]-z[j]) < ctof*ctof)
	      {
		cm[rid[i]][rid[j]]=1;
		cm[rid[j]][rid[i]]=1;
	      }
	  }
      }

    fclose(fp); // close single snashots
      
      // our 2D to 1D array conversion is i+(j-1)*csize
      for(i=1;i<=csize;i++)
	{
	  for(j=1;j<=csize;j++)
	    {
	      zm[i+(j-1)*csize]+=(cm[resa[i]][resb[i]]-avg[i])*(cm[resa[j]][resb[j]]-avg[j]);
	    }
	}

 }//ending loop m, reading frames

 fcovar=fopen("covar.dat","w");
 // output result
 for(i=1;i<=csize;i++)
   {  
   for(j=1;j<=csize;j++)
     {
       fprintf(fcovar,"%3d %3d %18.16f\n",i,j,zm[i+(j-1)*csize]/framecount); 
     }
   }

fclose(fcovar);
}
