//THIS CODE HAS BEEN FIXED AT READIN 

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define rsize X_RSIZE // number residue
#define asize X_ASIZE // atom number per system
#define LL X_LSIZE // exact number of the segments of the system 
#define ctof X_CTOF // cutoff distance

int main(int argc, char **argv){
FILE * fp;
FILE * fmean;
int m,i,j,l,k;
int L=rsize;
int iend, jend, istart, jstart;
int rid[asize+1];
float x[asize+1];
float y[asize+1];
float z[asize+1];
int cm[rsize+1][rsize+1];
int lm[rsize+1][rsize+1]; // RR level 
// float lm[LL+1][LL+1]; //SS level
char trash[100];
char pdb[115];
char pdbf[115];
 char line[200];
 char key1[200];
int framecount=0;


 
framecount=atoi(argv[1]);

for(i=1;i<=L;i++){   //initialize array
      for(j=1;j<=L;j++){
        lm[i][j]=0.0;
      }
}


for(m=1;m<=framecount;m++){  //loop through pdbs
  strcpy(pdb,"X_DATAPATH");
  sprintf(pdbf,"X_FILENAME.%d",m);
  strcat(pdb,pdbf);
  //  strcat(pdb,".pdb");
  printf("%s\n",pdb);
  fp=fopen(pdb,"r");

  //read in coords 
  i=0;
  while( fgets(line,sizeof(line), fp)) {

    sscanf(line, "%s", key1);
    if(!strncasecmp(key1, "ATOM",4))
      { i++;
      sscanf(line,"%s%s%s%s%d%f%f%f%s%s",trash,trash,trash,trash,&rid[i],&x[i],&y[i],&z[i],trash,trash);
      }
  }
   //        printf("fscanf loop done\n");
   //initialize array       
    for(i=1;i<=rsize;i++)
      {  
	for(j=1;j<=rsize;j++)
	  {
	    cm[i][j]=0;
	  } 
      }
    
    for(i=1;i<=asize;i++)   //check for contact
      {
      for(j=i;j<=asize;j++)
        {
         if ((x[i]-x[j])*(x[i]-x[j])+
	     (y[i]-y[j])*(y[i]-y[j])+
	     (z[i]-z[j])*(z[i]-z[j]) < ctof*ctof)
           {
           cm[rid[i]][rid[j]]=1;
	   cm[rid[j]][rid[i]]=1;
	   }
        }
      }
    // convert from single frame to sum
   for(i=1;i<=L;i++)
     {  
       for(j=i;j<=L;j++)
	 {   //update upper triangle only 
	   lm[i][j]+=cm[i][j];        
	 }  
     } 
      fclose(fp);
    }
// output mean.con
 fmean=fopen("mean.con","w");
  for(i=1;i<=L;i++)
    {   
     for(j=i;j<=L;j++)
       {
	 fprintf(fmean,"%d %d %.12e\n",i,j,(lm[i][j]*1.0/(framecount)));
       }
    }
  fclose(fmean);
}
