//THIS CODE read in a mean.con rsize by rsize and output covar of 2pca 

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define rsize 493 // 622 number residue



int main(int argc, char **argv){
FILE * fp;
FILE * fcovar;
FILE * cl;

 int m,i,j,l,k, ni, nj;
int L;
int iend, jend, istart, jstart;
double *avg; // store mean values from sel.con 
 double *zm; //the storage space for the cov matrix

 double *zdata; //the storage space for the man.con matrix
 char trash[100];
 char pdb[115];
 char pdbf[115];
 char line[200];
 char key1[200];

int framecount=0;

 zdata=malloc(sizeof(double)*(rsize*rsize+1)); // mean mat
 zm=malloc(sizeof(double)*(rsize*rsize+1)); // cov mat
  avg=malloc(sizeof(double)*(rsize+1));

 // if L==0, print no CG else print do CG
 //if(LL==0) { L=rsize;} else L=LL;
  for(i=1;i<=rsize;i++)
    {
      avg[i]=0.0;
    }
  

 cl=fopen("./data.con","r");
 // readin from sel.con define resa, resb, avg  
 for(i=1;i<=rsize*rsize;i++)
   {
     fscanf(cl,"%d%d%lf",&ni,&nj,&zdata[i]);
     avg[ni]+=zdata[i];
     //     printf("%d  %f\n", ni, avg[ni]);
   
   }

 // avg normalization
 for(i=1;i<=rsize;i++)
   {
     avg[i]/=(1.0*rsize);
     printf("%d  %f\n", i, avg[i]);
     
   }

  
 // framecount=atoi(argv[1]);

 // clear covar matrix 
 for(i=0;i<=rsize*rsize;i++) {   zm[i]=0.0;}
 
       // our 2D to 1D array conversion is i+(j-1)*rsize
 for(i=1;i<=rsize;i++) //between site i
	{
	  for(j=1;j<=rsize;j++) // and site j's cova
	    {
	      for(k=1;k<=rsize;k++) // loop throught the data set
		{
		  zm[i+(j-1)*rsize]+=((zdata[i+(k-1)*rsize]-avg[i])*(zdata[j+(k-1)*rsize]-avg[j]));
		}
	    }
	}

 fcovar=fopen("covar.dat","w");
 // output result
 for(i=1;i<=rsize;i++)
   {  
   for(j=1;j<=rsize;j++)
     {
       fprintf(fcovar,"%3d %3d %18.16f\n",i,j,zm[i+(j-1)*rsize]/rsize); 
     }
   }

fclose(fcovar);
}
